name: PHP CRC32

on: [push]

jobs:
  lint:
    runs-on: ubuntu-latest
    strategy:
      matrix:
        # No need to lint on every version, so pin this to the most recent version.
        php-version: ['8.2']

    steps:
      - uses: actions/checkout@v3

      - name: Setup PHP ${{ matrix.php-version }} with tools
        uses: shivammathur/setup-php@v2
        with:
          php-version: ${{ matrix.php-version }}
          tools: php-cs-fixer

      - name: Lint
        run: make lint

  test:
    runs-on: ${{ matrix.os }}
    strategy:
      matrix:
        os: [ubuntu-latest, macos-latest]
        php-version: ['7.4', '8.0', '8.1', '8.2']

    steps:
      - uses: actions/checkout@v3

      - name: Setup PHP ${{ matrix.php-version }} with tools
        uses: shivammathur/setup-php@v2
        with:
          php-version: ${{ matrix.php-version }}
          tools: phpunit phpize php-config

      - name: Install dependencies
        run: composer install --prefer-dist

      - name: Test
        run: make test
